import { AfterContentInit, EventEmitter, QueryList, TemplateRef } from '@angular/core';
import * as i0 from "@angular/core";
export type ModalTemplateType = 'header' | 'content' | 'footer';
export declare class ModalTemplate {
    readonly templateRef: TemplateRef<any>;
    private _name;
    set name(name: ModalTemplateType | null | undefined);
    get name(): ModalTemplateType | null | undefined;
    constructor(templateRef: TemplateRef<any>);
    static ɵfac: i0.ɵɵFactoryDeclaration<ModalTemplate, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<ModalTemplate, "ng-template[spModalTemplate]", never, { "name": { "alias": "spModalTemplate"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class ModalComponent implements AfterContentInit {
    modalTemplates: QueryList<ModalTemplate> | undefined;
    set visible(visible: boolean);
    set closable(closable: boolean);
    set blocking(blocking: boolean);
    set panelStyle(panelStyle: any);
    visibleChange: EventEmitter<boolean>;
    readonly visible$: import("@angular/core").WritableSignal<boolean>;
    readonly closable$: import("@angular/core").WritableSignal<boolean>;
    readonly blocking$: import("@angular/core").WritableSignal<boolean>;
    readonly panelStyle$: import("@angular/core").WritableSignal<any>;
    readonly headerTemplate$: import("@angular/core").WritableSignal<TemplateRef<any> | null>;
    readonly contentTemplate$: import("@angular/core").WritableSignal<TemplateRef<any> | null>;
    readonly footerTemplate$: import("@angular/core").WritableSignal<TemplateRef<any> | null>;
    ngAfterContentInit(): void;
    backdropClicked(): void;
    close(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ModalComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ModalComponent, "sp-modal", never, { "visible": { "alias": "visible"; "required": false; }; "closable": { "alias": "closable"; "required": false; }; "blocking": { "alias": "blocking"; "required": false; }; "panelStyle": { "alias": "panelStyle"; "required": false; }; }, { "visibleChange": "visibleChange"; }, ["modalTemplates"], never, false, never>;
}
